/****************************************************************************
Draw a simple arrow

Patrick Gerber <patrick.gerber@heig-vd.ch>
Copyright (c) 2008 ReDS Institute <reds.heig-vd.ch>
june 2008 - v0.1

Developped for ubidule under the Perplexus project
See www.perplexus.org for more informations

Released under the same licence as OLSR v0.5.5
See www.olsr.org for more informations
****************************************************************************/

#include "arrow.h"

void drawArrow(QPainter *p, QPointF from, QPointF to, int size, int blanc_dist)
{
	QPointF points[3];
	float a = atan2(from.y()-to.y(), from.x()-to.x());
	to.setX(to.x()+blanc_dist*cos(a));
	to.setY(to.y()+blanc_dist*sin(a));
	blanc_dist += size;
	from.setX(from.x()-blanc_dist*cos(a));
    from.setY(from.y()-blanc_dist*sin(a));
    a = atan2(from.y()-to.y(), from.x()-to.x());
	
	QPointF k(to.x()+size*cos(a), to.y()+size*sin(a));
	a += M_PI/2;
	size /= 2;
	QPointF i(k.x()+size*cos(a), k.y()+size*sin(a));
	QPointF j(k.x()-size*cos(a), k.y()-size*sin(a));
	
    p->drawLine(from, k);
    points[0] = to;
    points[1] = i;
    points[2] = j;
    p->drawConvexPolygon(points, 3);
}
