/****************************************************************************
Gui interface for OLSRD
Use the plugin txtinfo with patch for XML formatting

Patrick Gerber <patrick.gerber@heig-vd.ch>
Copyright (c) 2008 ReDS Institute <reds.heig-vd.ch>
june 2008 - v0.1

Developped for ubidule under the Perplexus project
See www.perplexus.org for more informations

Released under the same licence as OLSR v0.5.5
See www.olsr.org for more informations
****************************************************************************/

 #ifndef OLSRD_INFO_H
 #define OLSRD_INFO_H

 #include <QWidget>
 #include <QTcpSocket>
 #include <QTextEdit>
 #include <QDomDocument>
 #include <QToolTip>

 class QTcpSocket;
 class QDomDocument;
 class QTextEdit;

 class OlsrdInfo : public QWidget
 {
     Q_OBJECT

 public:
     OlsrdInfo(QString a_addr, QWidget *parent = 0);

 public slots:
     void socket_start();
     void socket_connected();
     void socket_readyRead();
     void socket_displayError(QAbstractSocket::SocketError socketError);
     void socket_disconnected();
     void mouseMoveEvent(QMouseEvent * event);

 protected:
	 void paintEvent(QPaintEvent*);
	 
	 
 private:
     QTimer *timer;
     QString *buf;
     QMap<QString, QString> *topologies;
     QMap<QString, QPointF> *posNodes;
     QMap<QString, QString> *nodesInfos;
     QString localIp, addr, selNode;
     int nodeSize;
     

     QTcpSocket tcpClient;
     int bytesToWrite;
     int bytesWritten;
     int bytesReceived;
     float anim;
 };

 #endif

